#!/bin/csh
################################################################################
echo 128x2 linear least squares examples
mpirun -np 1 ../bin/inputs -acre_e band -acre_q 1 -acre_b 128	\
	-acre_m 128 -acre_n 2 -acre_fA data/lsqr_A -acre_fb data/lsqr_b	\
	-acre_fsL data/lsqr_sL -acre_flb data/lsqr_lb	\
	-acre_fub data/lsqr_ub -acre_fx data/lsqr_x

mpirun -np 1 ../bin/inputs -acre_e band -acre_q 1 -acre_b 128	\
	-acre_m 128 -acre_n 2 -acre_fA data/lsqr_A_txt	\
	-acre_fb data/lsqr_b_txt -acre_fsL data/lsqr_sL_txt	\
	-acre_flb data/lsqr_lb_txt -acre_fub data/lsqr_ub_txt	\
	-acre_fx data/lsqr_x_txt -acre_ascii -acre_silent

################################################################################
echo 128x2 2-band examples
mpirun -np 1 ../bin/inputs -acre_e band -acre_q 2 -acre_b 128	\
	-acre_m 128 -acre_n 2 -acre_fA data/band_A	\
	-acre_fb data/band_b -acre_fsL data/band_sL	\
	-acre_flb data/band_lb -acre_fub data/band_ub	\
	-acre_fx data/band_x -acre_std 1.0e-7 -acre_silent

mpirun -np 1 ../bin/inputs -acre_e band -acre_q 2 -acre_b 128	\
	-acre_m 128 -acre_n 2 -acre_fA data/band_A_txt	\
	-acre_fb data/band_b_txt -acre_fsL data/band_sL_txt	\
	-acre_flb data/band_lb_txt -acre_fub data/band_ub_txt	\
	-acre_fx data/band_x_txt -acre_ascii -acre_std 1.0e-7 -acre_silent

################################################################################
echo 128x2 2x2-blocks examples
mpirun -np 1 ../bin/inputs -acre_e block -acre_b 2 -acre_m 128	\
	-acre_n 2 -acre_fA data/block_A -acre_fb data/block_b	\
	-acre_fsL data/block_sL -acre_flb data/block_lb	\
	-acre_fub data/block_ub -acre_fx data/block_x -acre_std 1.0e-2	\
	-acre_silent

mpirun -np 1 ../bin/inputs -acre_e block -acre_b 2 -acre_m 128	\
	-acre_n 2 -acre_fA data/block_A_txt -acre_fb data/block_b_txt	\
	-acre_fsL data/block_sL_txt -acre_flb data/block_lb_txt	\
	-acre_fub data/block_ub_txt -acre_fx data/block_x_txt	\
	-acre_ascii -acre_std 1.0e-2 -acre_silent


