/* $Id: acre_end.c,v 1.1 2004/04/30 05:16:13 Joel M. Malard Exp d3j540 $ */

#include "tao_solver.h"
#include "petscblaslapack.h"
#include "petsclog.h"
#include "acre.h"
#include "petsclog.h"
#include <assert.h>
#include <mpi.h>
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_end"
/* Sets up the application context */
int acre_end(acre_cntxt *cntxt)
{
	int ierr;

	HELLO("acre_end enter");

	cntxt->A = PETSC_NULL;
	cntxt->sL = PETSC_NULL;
	cntxt->m = 0;
	cntxt->n = 0;
	cntxt->nq = 0;
	cntxt->b = PETSC_NULL;

	cntxt->rn = 0;
	PetscFree(cntxt->rstart);

	ierr = MPI_Comm_free(&cntxt->rcomm);
		assert(ierr==MPI_SUCCESS);

	ierr = VecDestroy(cntxt->sLDiag);			CHKERRQ(ierr);

	ierr = KSPDestroy(cntxt->sles);				CHKERRQ(ierr);
	ierr = MatDestroy(cntxt->L);				CHKERRQ(ierr);
#if !defined(USE_PETSC_TRANSPOSE)
	ierr = KSPDestroy(cntxt->stes);				CHKERRQ(ierr);
	ierr = MatDestroy(cntxt->LTr);				CHKERRQ(ierr);
#endif
	ierr = MatDestroy(cntxt->Q);				CHKERRQ(ierr);
	ierr = MatDestroy(cntxt->B);				CHKERRQ(ierr);
	ierr = MatDestroy(cntxt->R);				CHKERRQ(ierr);
	ierr = VecDestroy(cntxt->u);				CHKERRQ(ierr);
	ierr = VecDestroy(cntxt->v);				CHKERRQ(ierr);
	ierr = VecDestroy(cntxt->w);				CHKERRQ(ierr);
	ierr = VecDestroy(cntxt->pVec);				CHKERRQ(ierr);
	ierr = VecDestroy(cntxt->gVec);				CHKERRQ(ierr);

	HELLO("acre_end exit");

	return 0;
}
