/*$Id: acre_print_vector_serial.c,v 1.1 2004/04/30 J. Malard Exp d3j540 $ */

#include <stdlib.h>
#include <assert.h>
#include "tao.h"
#include "acre.h"
#include "petscvec.h" 
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_print_vector_serial"
int acre_print_vector_serial(Vec b, char *infile, PetscTruth format)
{
	int ierr;
	PetscViewer fd;

	HELLO("acre_print_vector_serial enter");

	if ( format==PETSC_TRUE )
	{
		int i;
		int m;
		PetscScalar *vals;

		ierr = VecGetSize( b, &m);			CHKERRQ(ierr);

		ierr = PetscViewerASCIIOpen(PETSC_COMM_WORLD,
			infile, &fd);				CHKERRQ(ierr);
		PetscViewerASCIIPrintf(fd,"%d\n",m);

		ierr = VecGetArray( b, &vals);			CHKERRQ(ierr);
		for ( i=0; i<m; i++ )
		{
			PetscViewerASCIIPrintf(fd,"%lg\n",
				vals[i]);
		}
		ierr = VecRestoreArray( b, &vals);		CHKERRQ(ierr);
		ierr = PetscViewerDestroy(fd);			CHKERRQ(ierr);
	}
	else
	{
		ierr = PetscViewerBinaryOpen(PETSC_COMM_SELF,
			infile, PETSC_FILE_CREATE,&fd);		CHKERRQ(ierr);
		ierr = VecView(b,fd);				CHKERRQ(ierr);
		ierr = PetscViewerDestroy(fd);			CHKERRQ(ierr);
	}
	
	HELLO("acre_print_vector_serial exit");

	return ierr;
}
