/*$Id: acre_read_vector.c,v 1.1 2004/04/30 Joel M. Malard Exp d3j540 $ */

#include <stdlib.h>
#include <assert.h>
#include "acre.h"
#include "tao.h"
#include "petscvec.h" 
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_read_vector"
int acre_read_vector(MPI_Comm comm, char * infile, PetscTruth format, Vec * x)
{
	int ierr;

	HELLO("acre_read_vector enter");

	if ( format==PETSC_TRUE )
	{
		int j;
		int m;
		FILE *fp;
		int *rows;
		PetscScalar *vals;
		fp = fopen(infile,"r");		
			assert(fp!=NULL);
		ierr = fscanf(fp, "%d\n",&m);
			assert(ierr==1);

		ierr = VecCreateMPI( comm, PETSC_DECIDE,
			m, x);					CHKERRQ(ierr);

		ierr = PetscMalloc(m*sizeof(PetscScalar),
			&vals);					CHKERRQ(ierr);
		ierr = PetscMalloc(m*sizeof(int),&rows);	CHKERRQ(ierr);

		for ( j=0; j<m; j++ )
		{
			rows[j] = j;
			ierr = fscanf(fp,"%lg",&vals[j]);
				assert(ierr==1);
		}
		ierr = VecSetValues(*x, m, rows, vals,
			INSERT_VALUES);	CHKERRQ(ierr);		CHKERRQ(ierr);
		ierr = VecAssemblyBegin(*x);		 	CHKERRQ(ierr);
		ierr = VecAssemblyEnd(*x); 			CHKERRQ(ierr);

		ierr = PetscFree(vals);				CHKERRQ(ierr);
		ierr = PetscFree(rows);				CHKERRQ(ierr);

		fclose(fp);
	}
	else
	{
		PetscViewer  fd;
		ierr = PetscViewerBinaryOpen(PETSC_COMM_WORLD,
			infile, PETSC_FILE_RDONLY,&fd);		CHKERRQ(ierr);
		ierr = VecLoad(fd, VECMPI, x);			CHKERRQ(ierr);
		ierr = PetscViewerDestroy(fd);			CHKERRQ(ierr);
	}

	HELLO("acre_read_vector exit");

	return ierr;
}

